GLFW: Window handling

GLFW

- Documentation
- Download
- Media
- Community

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

All Data Structures Files Functions Variables Typedefs Macros Modules Pages
Typedefs | Functions
Window handling

## Typedefs
typedef struct GLFWwindow | GLFWwindow
| Opaque window object. More...
typedef void(* | GLFWwindowposfun )(GLFWwindow *, int, int)
| The function signature for window position callbacks. More...
typedef void(* | GLFWwindowsizefun )(GLFWwindow *, int, int)
| The function signature for window resize callbacks. More...
typedef void(* | GLFWwindowclosefun )(GLFWwindow *)
| The function signature for window close callbacks. More...
typedef void(* | GLFWwindowrefreshfun )(GLFWwindow *)
| The function signature for window content refresh callbacks. More...
typedef void(* | GLFWwindowfocusfun )(GLFWwindow *, int)
| The function signature for window focus/defocus callbacks. More...
typedef void(* | GLFWwindowiconifyfun )(GLFWwindow *, int)
| The function signature for window iconify/restore callbacks. More...
typedef void(* | GLFWframebuffersizefun )(GLFWwindow *, int, int)
| The function signature for framebuffer resize callbacks. More...

## Functions
void | glfwDefaultWindowHints (void)
| Resets all window hints to their default values. More...
void | glfwWindowHint (int target, int hint)
| Sets the specified window hint to the desired value. More...
GLFWwindow * | glfwCreateWindow (int width, int height, const char *title, GLFWmonitor *monitor, GLFWwindow *share)
| Creates a window and its associated context. More...
void | glfwDestroyWindow (GLFWwindow *window)
| Destroys the specified window and its context. More...
int | glfwWindowShouldClose (GLFWwindow *window)
| Checks the close flag of the specified window. More...
void | glfwSetWindowShouldClose (GLFWwindow *window, int value)
| Sets the close flag of the specified window. More...
void | glfwSetWindowTitle (GLFWwindow *window, const char *title)
| Sets the title of the specified window. More...
void | glfwGetWindowPos (GLFWwindow *window, int *xpos, int *ypos)
| Retrieves the position of the client area of the specified window. More...
void | glfwSetWindowPos (GLFWwindow *window, int xpos, int ypos)
| Sets the position of the client area of the specified window. More...
void | glfwGetWindowSize (GLFWwindow *window, int *width, int *height)
| Retrieves the size of the client area of the specified window. More...
void | glfwSetWindowSize (GLFWwindow *window, int width, int height)
| Sets the size of the client area of the specified window. More...
void | glfwGetFramebufferSize (GLFWwindow *window, int *width, int *height)
| Retrieves the size of the framebuffer of the specified window. More...
void | glfwGetWindowFrameSize (GLFWwindow *window, int *left, int *top, int *right, int *bottom)
| Retrieves the size of the frame of the window. More...
void | glfwIconifyWindow (GLFWwindow *window)
| Iconifies the specified window. More...
void | glfwRestoreWindow (GLFWwindow *window)
| Restores the specified window. More...
void | glfwShowWindow (GLFWwindow *window)
| Makes the specified window visible. More...
void | glfwHideWindow (GLFWwindow *window)
| Hides the specified window. More...
GLFWmonitor * | glfwGetWindowMonitor (GLFWwindow *window)
| Returns the monitor that the window uses for full screen mode. More...
int | glfwGetWindowAttrib (GLFWwindow *window, int attrib)
| Returns an attribute of the specified window. More...
void | glfwSetWindowUserPointer (GLFWwindow *window, void *pointer)
| Sets the user pointer of the specified window. More...
void * | glfwGetWindowUserPointer (GLFWwindow *window)
| Returns the user pointer of the specified window. More...
GLFWwindowposfun | glfwSetWindowPosCallback (GLFWwindow *window, GLFWwindowposfun cbfun)
| Sets the position callback for the specified window. More...
GLFWwindowsizefun | glfwSetWindowSizeCallback (GLFWwindow *window, GLFWwindowsizefun cbfun)
| Sets the size callback for the specified window. More...
GLFWwindowclosefun | glfwSetWindowCloseCallback (GLFWwindow *window, GLFWwindowclosefun cbfun)
| Sets the close callback for the specified window. More...
GLFWwindowrefreshfun | glfwSetWindowRefreshCallback (GLFWwindow *window, GLFWwindowrefreshfun cbfun)
| Sets the refresh callback for the specified window. More...
GLFWwindowfocusfun | glfwSetWindowFocusCallback (GLFWwindow *window, GLFWwindowfocusfun cbfun)
| Sets the focus callback for the specified window. More...
GLFWwindowiconifyfun | glfwSetWindowIconifyCallback (GLFWwindow *window, GLFWwindowiconifyfun cbfun)
| Sets the iconify callback for the specified window. More...
GLFWframebuffersizefun | glfwSetFramebufferSizeCallback (GLFWwindow *window, GLFWframebuffersizefun cbfun)
| Sets the framebuffer resize callback for the specified window. More...
void | glfwPollEvents (void)
| Processes all pending events. More...
void | glfwWaitEvents (void)
| Waits until events are queued and processes them. More...
void | glfwPostEmptyEvent (void)
| Posts an empty event to the event queue. More...
void | glfwSwapBuffers (GLFWwindow *window)
| Swaps the front and back buffers of the specified window. More...

## Detailed Description

This is the reference documentation for window related functions and types, including creation, deletion and event polling. For more information, see the Window guide.

## Typedef Documentation

typedef void(* GLFWframebuffersizefun)(GLFWwindow *, int, int)

This is the function signature for framebuffer resize callback functions.

Parameters

  [in] | window | The window whose framebuffer was resized.
  [in] | width | The new width, in pixels, of the framebuffer.
  [in] | height | The new height, in pixels, of the framebuffer.

See also
  glfwSetFramebufferSizeCallback

typedef struct GLFWwindow GLFWwindow

Opaque window object.

typedef void(* GLFWwindowclosefun)(GLFWwindow *)

This is the function signature for window close callback functions.

Parameters

  [in] | window | The window that the user attempted to close.

See also
  glfwSetWindowCloseCallback

typedef void(* GLFWwindowfocusfun)(GLFWwindow *, int)

This is the function signature for window focus callback functions.

Parameters

  [in] | window | The window that gained or lost input focus.
  [in] | focused | `GL_TRUE` if the window was given input focus, or `GL_FALSE` if it lost it.

See also
  glfwSetWindowFocusCallback

typedef void(* GLFWwindowiconifyfun)(GLFWwindow *, int)

This is the function signature for window iconify/restore callback functions.

Parameters

  [in] | window | The window that was iconified or restored.
  [in] | iconified | `GL_TRUE` if the window was iconified, or `GL_FALSE` if it was restored.

See also
  glfwSetWindowIconifyCallback

typedef void(* GLFWwindowposfun)(GLFWwindow *, int, int)

This is the function signature for window position callback functions.

Parameters

  [in] | window | The window that was moved.
  [in] | xpos | The new x-coordinate, in screen coordinates, of the upper-left corner of the client area of the window.
  [in] | ypos | The new y-coordinate, in screen coordinates, of the upper-left corner of the client area of the window.

See also
  glfwSetWindowPosCallback

typedef void(* GLFWwindowrefreshfun)(GLFWwindow *)

This is the function signature for window refresh callback functions.

Parameters

  [in] | window | The window whose content needs to be refreshed.

See also
  glfwSetWindowRefreshCallback

typedef void(* GLFWwindowsizefun)(GLFWwindow *, int, int)

This is the function signature for window size callback functions.

Parameters

  [in] | window | The window that was resized.
  [in] | width | The new width, in screen coordinates, of the window.
  [in] | height | The new height, in screen coordinates, of the window.

See also
  glfwSetWindowSizeCallback

## Function Documentation

GLFWwindow* glfwCreateWindow | ( | int | width,
|  | int | height,
|  | const char * | title,
|  | GLFWmonitor * | monitor,
|  | GLFWwindow * | share
| ) |  |

This function creates a window and its associated OpenGL or OpenGL ES context. Most of the options controlling how the window and its context should be created are specified with window hints.

Successful creation does not change which context is current. Before you can use the newly created context, you need to make it current. For information about the `share` parameter, see Context object sharing.

The created window, framebuffer and context may differ from what you requested, as not all parameters and hints are hard constraints. This includes the size of the window, especially for full screen windows. To query the actual attributes of the created window, framebuffer and context, see glfwGetWindowAttrib, glfwGetWindowSize and glfwGetFramebufferSize.

To create a full screen window, you need to specify the monitor the window will cover. If no monitor is specified, windowed mode will be used. Unless you have a way for the user to choose a specific monitor, it is recommended that you pick the primary monitor. For more information on how to query connected monitors, see Retrieving monitors.

For full screen windows, the specified size becomes the resolution of the window's desired video mode. As long as a full screen window has input focus, the supported video mode most closely matching the desired video mode is set for the specified monitor. For more information about full screen windows, including the creation of so called windowed full screen or borderless full screen windows, see "Windowed full screen" windows.

By default, newly created windows use the placement recommended by the window system. To create the window at a specific position, make it initially invisible using the GLFW_VISIBLE window hint, set its position and then show it.

If a full screen window has input focus, the screensaver is prohibited from starting.

Window systems put limits on window sizes. Very large or very small window dimensions may be overridden by the window system on creation. Check the actual size after creation.

The swap interval is not set during window creation and the initial value may vary depending on driver settings and defaults.

Parameters

  [in] | width | The desired width, in screen coordinates, of the window. This must be greater than zero.
  [in] | height | The desired height, in screen coordinates, of the window. This must be greater than zero.
  [in] | title | The initial, UTF-8 encoded window title.
  [in] | monitor | The monitor to use for full screen mode, or `NULL` to use windowed mode.
  [in] | share | The window whose context to share resources with, or `NULL` to not share resources.

Returns
  The handle of the created window, or `NULL` if an error occurred.

Remarks
  Windows: Window creation will fail if the Microsoft GDI software OpenGL implementation is the only one available.
  Windows: If the executable has an icon resource named `GLFW_ICON,` it will be set as the icon for the window. If no such icon is present, the `IDI_WINLOGO` icon will be used instead.
  Windows: The context to share resources with may not be current on any other thread.
  OS X: The GLFW window has no icon, as it is not a document window, but the dock icon will be the same as the application bundle's icon. For more information on bundles, see the Bundle Programming Guide in the Mac Developer Library.
  OS X: The first time a window is created the menu bar is populated with common commands like Hide, Quit and About. The About entry opens a minimal about dialog with information from the application's bundle. The menu bar can be disabled with a compile-time option.
  OS X: On OS X 10.10 and later the window frame will not be rendered at full resolution on Retina displays unless the `NSHighResolutionCapable` key is enabled in the application bundle's `Info.plist`. For more information, see High Resolution Guidelines for OS X in the Mac Developer Library. The GLFW test and example programs use a custom `Info.plist` template for this, which can be found as `CMake/MacOSXBundleInfo.plist.in` in the source tree.
  X11: There is no mechanism for setting the window icon yet.
  X11: Some window managers will not respect the placement of initially hidden windows.
  X11: Due to the asynchronous nature of X11, it may take a moment for a window to reach its requested state. This means you may not be able to query the final size, position or other attributes directly after window creation.

Reentrancy
  This function may not be called from a callback.

Thread Safety
  This function may only be called from the main thread.

See also
  Window creation
  glfwDestroyWindow

Since
  Added in GLFW 3.0. Replaces `glfwOpenWindow`.

void glfwDefaultWindowHints | ( | void |  | ) |

This function resets all window hints to their default values.

Thread Safety
  This function may only be called from the main thread.

See also
  Window creation hints
  glfwWindowHint

Since
  Added in GLFW 3.0.

void glfwDestroyWindow | ( | GLFWwindow * | window | ) |

This function destroys the specified window and its context. On calling this function, no further callbacks will be called for that window.

If the context of the specified window is current on the main thread, it is detached before being destroyed.

Parameters

  [in] | window | The window to destroy.

Note
  The context of the specified window must not be current on any other thread when this function is called.

Reentrancy
  This function may not be called from a callback.

Thread Safety
  This function may only be called from the main thread.

See also
  Window creation
  glfwCreateWindow

Since
  Added in GLFW 3.0. Replaces `glfwCloseWindow`.

void glfwGetFramebufferSize | ( | GLFWwindow * | window,
|  | int * | width,
|  | int * | height
| ) |  |

This function retrieves the size, in pixels, of the framebuffer of the specified window. If you wish to retrieve the size of the window in screen coordinates, see glfwGetWindowSize.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose framebuffer to query.
  [out] | width | Where to store the width, in pixels, of the framebuffer, or `NULL`.
  [out] | height | Where to store the height, in pixels, of the framebuffer, or `NULL`.

Thread Safety
  This function may only be called from the main thread.

See also
  Framebuffer size
  glfwSetFramebufferSizeCallback

Since
  Added in GLFW 3.0.

int glfwGetWindowAttrib | ( | GLFWwindow * | window,
|  | int | attrib
| ) |  |

This function returns the value of an attribute of the specified window or its OpenGL or OpenGL ES context.

Parameters

  [in] | window | The window to query.
  [in] | attrib | The window attribute whose value to return.

Returns
  The value of the attribute, or zero if an error occurred.

Remarks
  Framebuffer related hints are not window attributes. See Framebuffer related attributes for more information.
  Zero is a valid value for many window and context related attributes so you cannot use a return value of zero as an indication of errors. However, this function should not fail as long as it is passed valid arguments and the library has been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window attributes

Since
  Added in GLFW 3.0. Replaces `glfwGetWindowParam` and `glfwGetGLVersion`.

void glfwGetWindowFrameSize | ( | GLFWwindow * | window,
|  | int * | left,
|  | int * | top,
|  | int * | right,
|  | int * | bottom
| ) |  |

This function retrieves the size, in screen coordinates, of each edge of the frame of the specified window. This size includes the title bar, if the window has one. The size of the frame may vary depending on the window-related hints used to create it.

Because this function retrieves the size of each window frame edge and not the offset along a particular coordinate axis, the retrieved values will always be zero or positive.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose frame size to query.
  [out] | left | Where to store the size, in screen coordinates, of the left edge of the window frame, or `NULL`.
  [out] | top | Where to store the size, in screen coordinates, of the top edge of the window frame, or `NULL`.
  [out] | right | Where to store the size, in screen coordinates, of the right edge of the window frame, or `NULL`.
  [out] | bottom | Where to store the size, in screen coordinates, of the bottom edge of the window frame, or `NULL`.

Thread Safety
  This function may only be called from the main thread.

See also
  Window size

Since
  Added in GLFW 3.1.

GLFWmonitor* glfwGetWindowMonitor | ( | GLFWwindow * | window | ) |

This function returns the handle of the monitor that the specified window is in full screen on.

Parameters

  [in] | window | The window to query.

Returns
  The monitor, or `NULL` if the window is in windowed mode or an error occurred.

Thread Safety
  This function may only be called from the main thread.

See also
  Window monitor

Since
  Added in GLFW 3.0.

void glfwGetWindowPos | ( | GLFWwindow * | window,
|  | int * | xpos,
|  | int * | ypos
| ) |  |

This function retrieves the position, in screen coordinates, of the upper-left corner of the client area of the specified window.

Any or all of the position arguments may be `NULL`. If an error occurs, all non-`NULL` position arguments will be set to zero.

Parameters

  [in] | window | The window to query.
  [out] | xpos | Where to store the x-coordinate of the upper-left corner of the client area, or `NULL`.
  [out] | ypos | Where to store the y-coordinate of the upper-left corner of the client area, or `NULL`.

Thread Safety
  This function may only be called from the main thread.

See also
  Window position
  glfwSetWindowPos

Since
  Added in GLFW 3.0.

void glfwGetWindowSize | ( | GLFWwindow * | window,
|  | int * | width,
|  | int * | height
| ) |  |

This function retrieves the size, in screen coordinates, of the client area of the specified window. If you wish to retrieve the size of the framebuffer of the window in pixels, see glfwGetFramebufferSize.

Any or all of the size arguments may be `NULL`. If an error occurs, all non-`NULL` size arguments will be set to zero.

Parameters

  [in] | window | The window whose size to retrieve.
  [out] | width | Where to store the width, in screen coordinates, of the client area, or `NULL`.
  [out] | height | Where to store the height, in screen coordinates, of the client area, or `NULL`.

Thread Safety
  This function may only be called from the main thread.

See also
  Window size
  glfwSetWindowSize

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter.

void* glfwGetWindowUserPointer | ( | GLFWwindow * | window | ) |

This function returns the current value of the user-defined pointer of the specified window. The initial value is `NULL`.

Parameters

  [in] | window | The window whose pointer to return.

Thread Safety
  This function may be called from any thread. Access is not synchronized.

See also
  User pointer
  glfwSetWindowUserPointer

Since
  Added in GLFW 3.0.

void glfwHideWindow | ( | GLFWwindow * | window | ) |

This function hides the specified window if it was previously visible. If the window is already hidden or is in full screen mode, this function does nothing.

Parameters

  [in] | window | The window to hide.

Thread Safety
  This function may only be called from the main thread.

See also
  Window visibility
  glfwShowWindow

Since
  Added in GLFW 3.0.

void glfwIconifyWindow | ( | GLFWwindow * | window | ) |

This function iconifies (minimizes) the specified window if it was previously restored. If the window is already iconified, this function does nothing.

If the specified window is a full screen window, the original monitor resolution is restored until the window is restored.

Parameters

  [in] | window | The window to iconify.

Thread Safety
  This function may only be called from the main thread.

See also
  Window iconification
  glfwRestoreWindow

Since
  Added in GLFW 2.1.

  GLFW 3: Added window handle parameter.

void glfwPollEvents | ( | void |  | ) |

This function processes only those events that are already in the event queue and then returns immediately. Processing events will cause the window and input callbacks associated with those events to be called.

On some platforms, a window move, resize or menu operation will cause event processing to block. This is due to how event processing is designed on those platforms. You can use the window refresh callback to redraw the contents of your window when necessary during such operations.

On some platforms, certain events are sent directly to the application without going through the event queue, causing callbacks to be called outside of a call to one of the event processing functions.

Event processing is not required for joystick input to work.

Reentrancy
  This function may not be called from a callback.

Thread Safety
  This function may only be called from the main thread.

See also
  Event processing
  glfwWaitEvents

Since
  Added in GLFW 1.0.

void glfwPostEmptyEvent | ( | void |  | ) |

This function posts an empty event from the current thread to the event queue, causing glfwWaitEvents to return.

If no windows exist, this function returns immediately. For synchronization of threads in applications that do not create windows, use your threading library of choice.

Thread Safety
  This function may be called from any thread.

See also
  Event processing
  glfwWaitEvents

Since
  Added in GLFW 3.1.

void glfwRestoreWindow | ( | GLFWwindow * | window | ) |

This function restores the specified window if it was previously iconified (minimized). If the window is already restored, this function does nothing.

If the specified window is a full screen window, the resolution chosen for the window is restored on the selected monitor.

Parameters

  [in] | window | The window to restore.

Thread Safety
  This function may only be called from the main thread.

See also
  Window iconification
  glfwIconifyWindow

Since
  Added in GLFW 2.1.

  GLFW 3: Added window handle parameter.

GLFWframebuffersizefun glfwSetFramebufferSizeCallback | ( | GLFWwindow * | window,
|  | GLFWframebuffersizefun | cbfun
| ) |  |

This function sets the framebuffer resize callback of the specified window, which is called when the framebuffer of the specified window is resized.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Framebuffer size

Since
  Added in GLFW 3.0.

GLFWwindowclosefun glfwSetWindowCloseCallback | ( | GLFWwindow * | window,
|  | GLFWwindowclosefun | cbfun
| ) |  |

This function sets the close callback of the specified window, which is called when the user attempts to close the window, for example by clicking the close widget in the title bar.

The close flag is set before this callback is called, but you can modify it at any time with glfwSetWindowShouldClose.

The close callback is not triggered by glfwDestroyWindow.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Remarks
  OS X: Selecting Quit from the application menu will trigger the close callback for all windows.

Thread Safety
  This function may only be called from the main thread.

See also
  Window closing and close flag

Since
  Added in GLFW 2.5.

  GLFW 3: Added window handle parameter. Updated callback signature.

GLFWwindowfocusfun glfwSetWindowFocusCallback | ( | GLFWwindow * | window,
|  | GLFWwindowfocusfun | cbfun
| ) |  |

This function sets the focus callback of the specified window, which is called when the window gains or loses input focus.

After the focus callback is called for a window that lost input focus, synthetic key and mouse button release events will be generated for all such that had been pressed. For more information, see glfwSetKeyCallback and glfwSetMouseButtonCallback.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window input focus

Since
  Added in GLFW 3.0.

GLFWwindowiconifyfun glfwSetWindowIconifyCallback | ( | GLFWwindow * | window,
|  | GLFWwindowiconifyfun | cbfun
| ) |  |

This function sets the iconification callback of the specified window, which is called when the window is iconified or restored.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window iconification

Since
  Added in GLFW 3.0.

void glfwSetWindowPos | ( | GLFWwindow * | window,
|  | int | xpos,
|  | int | ypos
| ) |  |

This function sets the position, in screen coordinates, of the upper-left corner of the client area of the specified windowed mode window. If the window is a full screen window, this function does nothing.

Do not use this function to move an already visible window unless you have very good reasons for doing so, as it will confuse and annoy the user.

The window manager may put limits on what positions are allowed. GLFW cannot and should not override these limits.

Parameters

  [in] | window | The window to query.
  [in] | xpos | The x-coordinate of the upper-left corner of the client area.
  [in] | ypos | The y-coordinate of the upper-left corner of the client area.

Thread Safety
  This function may only be called from the main thread.

See also
  Window position
  glfwGetWindowPos

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter.

GLFWwindowposfun glfwSetWindowPosCallback | ( | GLFWwindow * | window,
|  | GLFWwindowposfun | cbfun
| ) |  |

This function sets the position callback of the specified window, which is called when the window is moved. The callback is provided with the screen position of the upper-left corner of the client area of the window.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window position

Since
  Added in GLFW 3.0.

GLFWwindowrefreshfun glfwSetWindowRefreshCallback | ( | GLFWwindow * | window,
|  | GLFWwindowrefreshfun | cbfun
| ) |  |

This function sets the refresh callback of the specified window, which is called when the client area of the window needs to be redrawn, for example if the window has been exposed after having been covered by another window.

On compositing window systems such as Aero, Compiz or Aqua, where the window contents are saved off-screen, this callback may be called only very infrequently or never at all.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window damage and refresh

Since
  Added in GLFW 2.5.

  GLFW 3: Added window handle parameter. Updated callback signature.

void glfwSetWindowShouldClose | ( | GLFWwindow * | window,
|  | int | value
| ) |  |

This function sets the value of the close flag of the specified window. This can be used to override the user's attempt to close the window, or to signal that it should be closed.

Parameters

  [in] | window | The window whose flag to change.
  [in] | value | The new value.

Thread Safety
  This function may be called from any thread. Access is not synchronized.

See also
  Window closing and close flag

Since
  Added in GLFW 3.0.

void glfwSetWindowSize | ( | GLFWwindow * | window,
|  | int | width,
|  | int | height
| ) |  |

This function sets the size, in screen coordinates, of the client area of the specified window.

For full screen windows, this function selects and switches to the resolution closest to the specified size, without affecting the window's context. As the context is unaffected, the bit depths of the framebuffer remain unchanged.

The window manager may put limits on what sizes are allowed. GLFW cannot and should not override these limits.

Parameters

  [in] | window | The window to resize.
  [in] | width | The desired width of the specified window.
  [in] | height | The desired height of the specified window.

Thread Safety
  This function may only be called from the main thread.

See also
  Window size
  glfwGetWindowSize

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter.

GLFWwindowsizefun glfwSetWindowSizeCallback | ( | GLFWwindow * | window,
|  | GLFWwindowsizefun | cbfun
| ) |  |

This function sets the size callback of the specified window, which is called when the window is resized. The callback is provided with the size, in screen coordinates, of the client area of the window.

Parameters

  [in] | window | The window whose callback to set.
  [in] | cbfun | The new callback, or `NULL` to remove the currently set callback.

Returns
  The previously set callback, or `NULL` if no callback was set or the library had not been initialized.

Thread Safety
  This function may only be called from the main thread.

See also
  Window size

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter. Updated callback signature.

void glfwSetWindowTitle | ( | GLFWwindow * | window,
|  | const char * | title
| ) |  |

This function sets the window title, encoded as UTF-8, of the specified window.

Parameters

  [in] | window | The window whose title to change.
  [in] | title | The UTF-8 encoded window title.

Remarks
  OS X: The window title will not be updated until the next time you process events.

Thread Safety
  This function may only be called from the main thread.

See also
  Window title

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter.

void glfwSetWindowUserPointer | ( | GLFWwindow * | window,
|  | void * | pointer
| ) |  |

This function sets the user-defined pointer of the specified window. The current value is retained until the window is destroyed. The initial value is `NULL`.

Parameters

  [in] | window | The window whose pointer to set.
  [in] | pointer | The new value.

Thread Safety
  This function may be called from any thread. Access is not synchronized.

See also
  User pointer
  glfwGetWindowUserPointer

Since
  Added in GLFW 3.0.

void glfwShowWindow | ( | GLFWwindow * | window | ) |

This function makes the specified window visible if it was previously hidden. If the window is already visible or is in full screen mode, this function does nothing.

Parameters

  [in] | window | The window to make visible.

Thread Safety
  This function may only be called from the main thread.

See also
  Window visibility
  glfwHideWindow

Since
  Added in GLFW 3.0.

void glfwSwapBuffers | ( | GLFWwindow * | window | ) |

This function swaps the front and back buffers of the specified window. If the swap interval is greater than zero, the GPU driver waits the specified number of screen updates before swapping the buffers.

Parameters

  [in] | window | The window whose buffers to swap.

Thread Safety
  This function may be called from any thread.

See also
  Buffer swapping
  glfwSwapInterval

Since
  Added in GLFW 1.0.

  GLFW 3: Added window handle parameter.

void glfwWaitEvents | ( | void |  | ) |

This function puts the calling thread to sleep until at least one event is available in the event queue. Once one or more events are available, it behaves exactly like glfwPollEvents, i.e. the events in the queue are processed and the function then returns immediately. Processing events will cause the window and input callbacks associated with those events to be called.

Since not all events are associated with callbacks, this function may return without a callback having been called even if you are monitoring all callbacks.

On some platforms, a window move, resize or menu operation will cause event processing to block. This is due to how event processing is designed on those platforms. You can use the window refresh callback to redraw the contents of your window when necessary during such operations.

On some platforms, certain callbacks may be called outside of a call to one of the event processing functions.

If no windows exist, this function returns immediately. For synchronization of threads in applications that do not create windows, use your threading library of choice.

Event processing is not required for joystick input to work.

Reentrancy
  This function may not be called from a callback.

Thread Safety
  This function may only be called from the main thread.

See also
  Event processing
  glfwPollEvents

Since
  Added in GLFW 2.5.

void glfwWindowHint | ( | int | target,
|  | int | hint
| ) |  |

This function sets hints for the next call to glfwCreateWindow. The hints, once set, retain their values until changed by a call to glfwWindowHint or glfwDefaultWindowHints, or until the library is terminated.

Parameters

  [in] | target | The window hint to set.
  [in] | hint | The new value of the window hint.

Thread Safety
  This function may only be called from the main thread.

See also
  Window creation hints
  glfwDefaultWindowHints

Since
  Added in GLFW 3.0. Replaces `glfwOpenWindowHint`.

int glfwWindowShouldClose | ( | GLFWwindow * | window | ) |

This function returns the value of the close flag of the specified window.

Parameters

  [in] | window | The window to query.

Returns
  The value of the close flag.

Thread Safety
  This function may be called from any thread. Access is not synchronized.

See also
  Window closing and close flag

Since
  Added in GLFW 3.0.